/*
                           Copyright (C) 1995 
             John R.Callahan, Sudhakar Ramakrishnan, Sun Wei.
	         Web Integrated Software Project 
                   Management and Metrics Tool
                           (WISE)

WISE [both binary and source] (hereafter, Software) is 
copyrighted by John R.Callahan, Sudhakar Ramakrishnan , Sun Wei and 
ownership remains with the authors.

The authors grant you (hereafter, Licensee), a license to use the Software
for academic, research and internal business purposes only, without a
fee.  Licensee may distribute the binary to third parties providing 
that the copyright notice and this statement appears on all copies and
that no charge is associated with such copies. 

Licensee may make derivative works.  However, if Licensee distributes
any derivative work based on or derived from the Software, then
Licensee will (1) notify the authors regarding its distribution of 
the derivative work, and (2) clearly notify users that such derivative 
work is a modified version and not the original WISE tool distributed 
by the authors.

Any Licensee wishing to make commercial use of the Software should
contact the authors to negotiate an appropriate license for such
commercial use.  Commercial use includes (1) integration of all or
part of the source code into a product for sale or license by or on
behalf of licensee to third parties, or (2) distribution of the binary
code or source code to third parties that need it to utilize a
commercial product sold or licensed by or on behalf of Licensee.

THE AUTHORS MAKE NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS 
SOFTWARE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR 
IMPLIED WARRANTY.  THE AUTHORS SHALL NOT BE LIABLE FOR ANY DAMAGES
SUFFERED BY USERS OF THIS SOFTWARE.

By using or copying this Software, Licensee agrees to abide by the
copyright law and all other applicable laws of the U.S., including but
not limited, to, export control laws, and the terms of this license.
The authors shall have the right to terminate this license immediately by
written notice upon Licensee's breach of, or non-compliance with, any
of its terms.  Licensee may be held legally responsible for any
copyright infringement that is caused, directly or indirectly, by
Licensee's failure to abide by the terms of this license.

Direct notices to:
	
	John R.Callahan 
	886 Chestnut Ridge Road
	Concurrent Engineering Research Center
	West Virginia University
	Morgantown, WV 26505
	USA

	phone:	(304) 293-7226
	email:	callahan@cerc.wvu.edu
*/

#define WISEMAIN 1

#include <stdio.h>
#include <time.h>
#include "msql.h"
#include "wise.h"

int maxcount = 0;

struct item {
  char str[WISEBUFMAX];
  int count;
  struct item *next;
} *head = NULL;

void
resetcount()
{
  head = NULL;
  maxcount = 0;
}

void
addcount(char* str)
{
  struct item *p;

  for(p=head;p != NULL;p=p->next) {
    if(strcmp(p->str,str) == 0) {
      p->count++;
      if(p->count > maxcount) maxcount = p->count;
      return;
    }
  }
  p = (struct item *)malloc(sizeof(struct item));
  strcpy(p->str,str);
  p->count = 1;
  if(p->count > maxcount) maxcount = p->count;
  p->next = head;
  head = p;
  return;
}

main()
{
  int sock;
  int i,j,k=1,rows;
  char tbuf[WISEBUFMAX];
  char dbuf[WISEBUFMAX];
  struct item *p;
  m_result *result;
  m_row *row;
  time_t ts1970;
  struct tm *pstm;
  FILE *f,*pf;
  char* db;
  char* dbhost;

  ts1970 = time(NULL);
  /* cftime(dbuf,"%Y-%m-%d %T %Z",&ts1970); */
  pstm = localtime (&ts1970);
  strftime(dbuf,WISEBUFMAX,"%Y-%m-%d %T %Z",pstm);

  for(i=0;wiseproject[i].projectname != NULL;i++) {

    if((dbhost = wise_getprojhost(wiseproject[i].projectname)) == NULL) {
      printf("<H1>Could not find project database host!</H1>");
      return;
    }

    wise_setprojport(wiseproject[i].projectname);
    if((sock = msqlConnect(dbhost)) < 0) {
      printf("<H1>Connect error: %s</H1>",msqlErrMsg);
printf (" its %s %d \n", dbhost, sock);
      return;
    }


    if((db = wise_getprojdb(wiseproject[i].projectname)) == NULL) {
      printf("<H1>Could not get project's database name!</H1>");
      return;
    }

    if(msqlSelectDB(sock,db) < 0) {
      fprintf(stderr,"Cannot connect to database %s!\n",db);
      return -1;
    }

    sprintf(tbuf,"%s/%s.metrics",WISE_METRICDIR,
	    wiseproject[i].projectname);
    if((pf = fopen(tbuf,"w+")) == NULL) {
      fprintf(stderr,"Cannot create file %s!\n",tbuf);
      return -1;
    }
    fprintf(pf,"Metrics for %s\n",
	    wise_getprojlabel(wiseproject[i].projectname));
    fclose(pf);

    sprintf(tbuf,"%s/%s-metrics-histo.html",WISE_METRICDIR,
	    wiseproject[i].projectname);
    if((pf = fopen(tbuf,"w+")) == NULL) {
      fprintf(stderr,"Cannot create file %s!\n",tbuf);
      return -1;
    }
    fprintf(pf,"<!DOCTYPE HTML SYSTEM \"html.dtd\">\n");
    fprintf(pf,"<HTML>\n");
    fprintf(pf,"<HEAD>\n");
    fprintf(pf,"<TITLE>Project %s Metrics</TITLE>\n",
	    wise_getprojlabel(wiseproject[i].projectname));
    fprintf(pf,"</HEAD>\n");
    fprintf(pf,"<BODY BACKGROUND=\"%s\"",WISEBKGND);
    fprintf(pf,"TEXT=\"000000\"");
    fprintf(pf,"LINK=\"0000ff\" VLINK=\"0000ff\">\n");
    fprintf(pf,"<BASEFONT SIZE=4>\n");
    fprintf(pf,"<center>\n");
    fprintf(pf,"<table border=1 cellpadding=1>\
        <tr><td rowspan=4><table border=5 cellpadding=5><tr><td>\
        <center><IMG SRC=\"%s\" align=center><BR>A WISE application<BR>&copy 1995 <A HREF=\"http://research.ivv.nasa.gov/\">West Virginia University</A></center></td></tr></table></td></tr>\
        <tr><td><H2>%s Metrics</H2></td></tr>\
        <tr><td><H2>as of %s</H2></td></tr>\
        </table></center><BR><HR>\
        ",wise_getprojimage(wiseproject[i].projectname),wise_getprojlabel(wiseproject[i].projectname),dbuf);


    for(j=0;wiseproject[i].fields[j].field != NULL;j++) {
      if((wiseproject[i].fields[j].fieldtype == WISE_SELECT)
	 || (wiseproject[i].fields[j].fieldtype == WISE_RADIO)
	 || (wiseproject[i].fields[j].fieldtype == WISE_CBOX)) {
	sprintf(tbuf,"select %s from %s order by %s DESC",
		wiseproject[i].fields[j].field,
		wiseproject[i].projectname,
		wiseproject[i].fields[j].field);
	if(msqlQuery(sock,tbuf) < 0) {
	  printf("<H1>Query error: %s</H1>",msqlErrMsg);
	  return -1;
	}
	result = msqlStoreResult();
	resetcount();
	rows = 0;
	while((row = msqlFetchRow(result)) != NULL) {
	  if(strlen(row[0]) > 0) { addcount(row[0]); rows++; }
	}

	fprintf(pf,"<table border=1 cellpadding=1>\n");
	fprintf(pf,"<tr><td rowspan=%d>",rows+2);
	fprintf(pf,"<A HREF=\"http:/%s%s-%s-histo.html\">",
	  WISEMETRICS,wiseproject[i].projectname,
          wiseproject[i].fields[j].field);
	fprintf(pf,"<IMG SRC=\"http:/%shistoS-%s-%s.gif\"></A>",
		WISEMETRICS,wiseproject[i].projectname,
		wiseproject[i].fields[j].field);
	fprintf(pf,"</tr>\n");
	fprintf(pf,"<tr><td>%s<td>Number of Issues</tr>\n",
		wiseproject[i].fields[j].field);
	for(p=head;p != NULL;p=p->next) {
	  fprintf(pf,"<tr><td>%s<td>%d</tr>\n",p->str,p->count);
	}	
	fprintf(pf,"</table>\n");

	sprintf(tbuf,"%s/histo.%s.metric",
	  WISE_METRICDIR,wiseproject[i].projectname);
	if((f=fopen(tbuf,"w+")) == NULL) {
	  fprintf(stderr,"Cannot create file %s!\n",tbuf);
	  return -1;
	}
	fprintf(f,"Histogram metrics for %s\n",
		wise_getprojlabel(wiseproject[i].projectname));
	fclose(f);

	sprintf(tbuf,"%s/%s-%s-histo.html",
	  WISE_METRICDIR,wiseproject[i].projectname,
          wiseproject[i].fields[j].field);
	if((f=fopen(tbuf,"w+")) == NULL) {
	  fprintf(stderr,"Cannot create file %s!\n",tbuf);
	  return -1;
	}
	fprintf(f,"<!DOCTYPE HTML SYSTEM \"html.dtd\">\n");
	fprintf(f,"<HTML>\n");
	fprintf(f,"<HEAD>\n");
	fprintf(f,"<TITLE>Project %s Metrics for %s (as of %s)</TITLE>\n",
		wise_getprojlabel(wiseproject[i].projectname),
		wiseproject[i].fields[j].field,dbuf);
	fprintf(f,"</HEAD>\n");
	fprintf(f,"<BODY BACKGROUND=\"%s\"",WISEBKGND);
	fprintf(f,"TEXT=\"000000\"");
	fprintf(f,"LINK=\"0000ff\" VLINK=\"0000ff\">\n");
	fprintf(f,"<BASEFONT SIZE=4>\n");
	fprintf(f,"<table border=1 cellpadding=1>\
          <tr><td rowspan=4><table border=5 cellpadding=5><tr><td>\
          <center><IMG SRC=\"%s\" align=center><BR>A WISE application<BR>&copy 1995 <A HREF=\"http://research.ivv.nasa.gov/\">West Virginia University</A></center></td></tr></table></td></tr>\
          <tr><td><H2>%s Metrics for %s</H2></td></tr>\
          <tr><td><H2>as of %s</H2></td></tr>\
          </table></center><HR>\
          ",wise_getprojimage(wiseproject[i].projectname),
		wise_getprojlabel(wiseproject[i].projectname),
		wiseproject[i].fields[j].field,
		dbuf);

	fprintf(f,"<A HREF=\"http:/%shistoL-%s-%s.gif\"><IMG SRC=\"http:/%shistoL-%s-%s.gif\"></A><BR>",
		WISEMETRICS,
		wiseproject[i].projectname,
		wiseproject[i].fields[j].field,
		WISEMETRICS,
		wiseproject[i].projectname,
		wiseproject[i].fields[j].field);
	fprintf(f,"<center>\n");
	fclose(f);
	
	sprintf(tbuf,"%s/histo-%s-%s.dat",WISE_METRICDIR,
		wiseproject[i].projectname,wiseproject[i].fields[j].field);
	if((f = fopen(tbuf,"w+")) == NULL) {
	  fprintf(stderr,"Cannot create file %s!\n",tbuf);
	  return -1;
	}
	k = 1;
	for(p=head;p != NULL;p=p->next) {
	  fprintf(f,"%d %d\n",k,(p->count <= 0) ? 1 : p->count);
	  k = k + 2;
	}
	fclose(f);

	/* big picture */
	sprintf(tbuf,"%s/histoL-%s-%s.gp",WISE_METRICDIR,
		wiseproject[i].projectname,wiseproject[i].fields[j].field);
	if((f = fopen(tbuf,"w+")) == NULL) {
	  fprintf(stderr,"Cannot create file %s!\n",tbuf);
	  return -1;
	}
	fprintf(f,"set term pbm color\n");
	fprintf(f,"cd '%s'\n",WISE_METRICDIR);
	fprintf(f,"set output \"histoL-%s-%s.pbm\"\n",
		wiseproject[i].projectname,wiseproject[i].fields[j].field);
	fprintf(f,"set boxwidth 1\n");
	fprintf(f,"set size 0.9, 0.45\n");
	if(head != NULL) {
	  fprintf(f,"set xtics (");
	  k = 1;
	  for(p=head;p != NULL;p=p->next) {
	    char ch;
	    ch = p->str[8];
	    p->str[8] = '\0';
	    fprintf(f,"\"%s\" %d",p->str,k);
	    p->str[8] = ch;
	    if(p->next != NULL) fprintf(f,", ");
	    k = k + 2;
	  }
	}
	fprintf(f,")\n");
	fprintf(f,"set nokey\n");
	fprintf(f,"set title \"\"\n");
	fprintf(f,"set ylabel \"Number of Issues\" 0,0\n");
	fprintf(f,"set xlabel \"\"\n");
	fprintf(f,"set xrange [0:%d]\n",k-1);
	fprintf(f,"set yrange [0:%d]\n",maxcount+2);
	fprintf(f,"plot \"%s/histo-%s-%s.dat\"",WISE_METRICDIR,
		wiseproject[i].projectname,wiseproject[i].fields[j].field);
	fprintf(f," t \"\" with boxes 1 1 fill\n");
	fclose(f);

	/* small picture */
	sprintf(tbuf,"%s/histoS-%s-%s.gp",WISE_METRICDIR,
		wiseproject[i].projectname,wiseproject[i].fields[j].field);
	if((f = fopen(tbuf,"w+")) == NULL) {
	  fprintf(stderr,"Cannot create file %s!\n",tbuf);
	  return -1;
	}
	fprintf(f,"set term pbm color\n");
	fprintf(f,"cd '%s'\n",WISE_METRICDIR);
	fprintf(f,"set output \"histoS-%s-%s.pbm\"\n",
		wiseproject[i].projectname,wiseproject[i].fields[j].field);
	fprintf(f,"set boxwidth 1\n");
	fprintf(f,"set size 0.3, 0.3\n");
	if(head != NULL) {
	  fprintf(f,"set xtics (");
	  k = 1;
	  for(p=head;p != NULL;p=p->next) {
	    fprintf(f,"\"\" %d",k);
	    if(p->next != NULL) fprintf(f,", ");
	    k = k + 2;
	  }
	}
	fprintf(f,")\n");
	fprintf(f,"set nokey\n");
	fprintf(f,"set title \"\"\n");
	fprintf(f,"set ylabel \"Number of Issues\" 0,0\n");
	fprintf(f,"set xlabel \"%s\"\n",wiseproject[i].fields[j].field);
	fprintf(f,"set xrange [0:%d]\n",k-1);
	fprintf(f,"set yrange [0:%d]\n",maxcount+2);
	fprintf(f,"plot \"%s/histo-%s-%s.dat\"",WISE_METRICDIR,
		wiseproject[i].projectname,wiseproject[i].fields[j].field);
	fprintf(f," t \"\" with boxes 1 1 fill\n");
	fclose(f);

	msqlFreeResult(result);
      }
    }
    fprintf(pf,"</center>");
    fclose(pf);
    msqlClose(sock);
  }
  return 0;
}


